import type { INode } from '@sentry-internal/rrweb-snapshot';
export interface DomHandlerData {
    name: string;
    event: Node | {
        target: EventTarget;
    };
}
/**
 * For clicks, we check if the target is inside of a button or link
 * If so, we use this as the target instead
 * This is useful because if you click on the image in <button><img></button>,
 * The target will be the image, not the button, which we don't want here
 */
export declare function getClickTargetNode(event: DomHandlerData['event'] | MouseEvent): Node | INode | null;
/** Get the event target node. */
export declare function getTargetNode(event: Node | {
    target: EventTarget | null;
}): Node | INode | null;
//# sourceMappingURL=domUtils.d.ts.map